#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/mapreduce_opts.sh

input=$1
output=$2
workers=$3
threshold=$4

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# pacc
hadoop jar $DIR/$jarname \
  pegasus.mapreduce.cc.PACC \
  -D mapreduce.map.java.opts="$mapper_opts" -D mapreduce.map.memory.mb=$mapper_memory \
  -D mapreduce.reduce.java.opts="$reducer_opts" -D mapreduce.reduce.memory.mb=$reducer_memory \
  -D verbose=true -D localThreshold=$threshold -D mapred.reduce.tasks=$workers \
  -D mapreduce.map.output.compress=true -D mapreduce.map.output.compress.codec=$codec \
  $input $output
