#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/spark_opts.sh

input=$1
partitioned=$2
output=$3
threshold=$4
blocks=$5
workers=$6
if [ ! -z "$7" ]; then
  max_iter=$7
else
  max_iter=-1
fi

if [ ! -z "$8" ]; then
  alpha=$8
else
  alpha=0.85
fi

if [ ! -z "$9" ]; then
  source_vertex=$9
else
  source_vertex=-1
fi

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

if [ ! -z "$9" ]; then
$spark_home/bin/spark-submit \
  --class pegasus.spark.pagerank.PageRankComputation \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname -b $blocks -t $threshold -i $max_iter -sv $source_vertex -a $alpha -tp $partitioned $input $output
else
$spark_home/bin/spark-submit \
  --class pegasus.spark.pagerank.PageRankComputation \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname -b $blocks -t $threshold -i $max_iter -a $alpha -tp $partitioned $input $output
fi
