#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/spark_opts.sh

num_colors=$1
input=$2
ordered=$input.ordered
pattern_str=$3
workers=$4

if [ ! -z "$5" ]; then
  output=$5
  
  hdfs dfs -test -e $output
  if [[ $? -eq 0 ]]; then
    hdfs dfs -rm -r $output
  fi
fi

# edge order
$spark_home/bin/spark-submit \
  --class pegasus.spark.subgraph.EdgeOrder \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname $input $ordered

# pse
$spark_home/bin/spark-submit \
  --class pegasus.spark.subgraph.PSE \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname -p $num_colors -q $pattern_str $ordered $output

hdfs dfs -rm -r $ordered
