#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/spark_opts.sh

input=$1
partitioned=$2
output=$3
threshold=$4
blocks=$5
source_vertex=$6
workers=$7

if [ ! -z "$8" ]; then
  max_iter=$8
else
  max_iter=-1
fi

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# sssp
$spark_home/bin/spark-submit \
  --class pegasus.spark.sssp.SSSPComputation \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname -b $blocks -t $threshold -i $max_iter -tp $partitioned $input $output $source_vertex
