#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/mapreduce_opts.sh

seed=$1
level=$2
workers=$3
output=$4

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# kronecker
hadoop jar $DIR/$jarname \
  pegasus.mapreduce.graphgen.KroneckerGenerator \
  -D mapreduce.map.java.opts="$mapper_opts" -D mapreduce.map.memory.mb=$mapper_memory \
  -D mapreduce.reduce.java.opts="$reducer_opts" -D mapreduce.reduce.memory.mb=$reducer_memory \
  $seed $level $workers $output
