#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/mapreduce_opts.sh

num_nodes=$1
num_edges=$2
workers=$3
output=$4

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# random
hadoop jar $DIR/$jarname \
  pegasus.mapreduce.graphgen.RandomGenerator \
  -D mapreduce.map.java.opts="$mapper_opts" -D mapreduce.map.memory.mb=$mapper_memory \
  -D mapreduce.reduce.java.opts="$reducer_opts" -D mapreduce.reduce.memory.mb=$reducer_memory \
  $num_nodes $num_edges $workers $output
