#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/spark_opts.sh

num_nodes=$1
num_edges=$2
workers=$3
output=$4

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# random
$spark_home/bin/spark-submit \
  --class pegasus.spark.graphgen.RandomGenerator \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname $num_nodes $num_edges $workers $output
