#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/mapreduce_opts.sh

level=$1
edges=$2
workers=$3
a=$4
b=$5
c=$6
d=$7
noise=$8
output=$9

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# rmat
hadoop jar $DIR/$jarname \
  pegasus.mapreduce.graphgen.RMATGenerator \
  -D mapreduce.map.java.opts="$mapper_opts" -D mapreduce.map.memory.mb=$mapper_memory \
  -D mapreduce.reduce.java.opts="$reducer_opts" -D mapreduce.reduce.memory.mb=$reducer_memory \
  $level $edges $workers $a $b $c $d $noise $output
