#!/usr/bin/env bash

DIR=$(dirname "$(readlink -f "$0")")

source $DIR/spark_opts.sh

level=$1
edges=$2
workers=$3
a=$4
b=$5
c=$6
d=$7
noise=$8
output=$9

hdfs dfs -test -e $output
if [[ $? -eq 0 ]]; then
  hdfs dfs -rm -r $output
fi

# rmat
$spark_home/bin/spark-submit \
  --class pegasus.spark.graphgen.RMATGenerator \
  --master $spark_master --executor-memory $worker_memory --executor-cores $worker_cores \
  --deploy-mode client --num-executors $workers --conf "spark.executor.extraJavaOptions=$worker_opts" \
  $DIR/$jarname $level $edges $workers $a $b $c $d $noise $output
