/*
 * PegasusN: Peta-Scale Graph Mining System v3.0
 * Authors: Chiwan Park, Ha-Myung Park, U Kang
 *
 * This software is licensed under Apache License, Version 2.0 (the  "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * -------------------------------------------------------------------------
 * File: VectorCache.java
 * - Interface for cache of vector elements
 * Version: 3.0
 */
package pegasus.mapreduce.common.cache;

import org.apache.hadoop.io.Writable;

public interface VectorCache<V extends Writable> {
  int size();

  V get(final int i);

  boolean contains(final int i);

  void put(final int i, final V value);

  void addTo(final int i, final V value);

  void clear();

  VectorIterator<V> iterator(boolean onlyNonZero, final BitSet filterSet);
}
