package pegasus.mapreduce.common.coordination;

import org.apache.zookeeper.ZooKeeper;

import java.util.function.BinaryOperator;

public class ZookeeperBooleanCounter extends ZookeeperCounter<Boolean> {
  public ZookeeperBooleanCounter(ZooKeeper zk, String name, int workerId) {
    super(zk, name, workerId);
  }

  @Override
  protected Boolean negativeInfinite() {
    return false;
  }

  @Override
  protected Boolean positiveInfinite() {
    return true;
  }

  @Override
  protected Boolean zero() {
    return false;
  }

  @Override
  protected BinaryOperator<Boolean> sumOp() {
    return (a, b) -> a | b;
  }

  @Override
  protected Boolean valueFromString(String string) {
    return "true".equalsIgnoreCase(string);
  }

  @Override
  protected String valueToString(Boolean value) {
    return value.toString();
  }
}
