package pegasus.mapreduce.common.coordination;

import org.apache.zookeeper.ZooKeeper;

import java.util.function.BinaryOperator;

public class ZookeeperDoubleCounter extends ZookeeperCounter<Double> {
  public ZookeeperDoubleCounter(ZooKeeper zk, String name, int workerId) {
    super(zk, name, workerId);
  }

  @Override
  protected Double negativeInfinite() {
    return Double.MIN_VALUE;
  }

  @Override
  protected Double positiveInfinite() {
    return Double.MAX_VALUE;
  }

  @Override
  protected Double zero() {
    return 0.0;
  }

  @Override
  protected BinaryOperator<Double> sumOp() {
    return (a, b) -> a + b;
  }

  @Override
  protected Double valueFromString(final String string) {
    return Double.parseDouble(string);
  }

  @Override
  protected String valueToString(final Double value) {
    return value.toString();
  }
}
