package pegasus.mapreduce.common.coordination;

import org.apache.zookeeper.ZooKeeper;

import java.util.function.BinaryOperator;

public class ZookeeperIntegerCounter extends ZookeeperCounter<Integer> {
  public ZookeeperIntegerCounter(ZooKeeper zk, String name, int workerId) {
    super(zk, name, workerId);
  }

  @Override
  protected Integer negativeInfinite() {
    return Integer.MIN_VALUE;
  }

  @Override
  protected Integer positiveInfinite() {
    return Integer.MAX_VALUE;
  }

  @Override
  protected Integer zero() {
    return 0;
  }

  @Override
  protected BinaryOperator<Integer> sumOp() {
    return (a, b) -> a + b;
  }

  @Override
  protected Integer valueFromString(String string) {
    return Integer.parseInt(string);
  }

  @Override
  protected String valueToString(Integer value) {
    return value.toString();
  }
}
