package pegasus.mapreduce.common.coordination;

import org.apache.zookeeper.ZooKeeper;

import java.util.function.BinaryOperator;

public class ZookeeperLongCounter extends ZookeeperCounter<Long> {
  public ZookeeperLongCounter(ZooKeeper zk, String name, int workerId) {
    super(zk, name, workerId);
  }

  @Override
  protected Long negativeInfinite() {
    return Long.MIN_VALUE;
  }

  @Override
  protected Long positiveInfinite() {
    return Long.MAX_VALUE;
  }

  @Override
  protected Long zero() {
    return 0L;
  }

  @Override
  protected BinaryOperator<Long> sumOp() {
    return (a, b) -> a + b;
  }

  @Override
  protected Long valueFromString(final String string) {
    return Long.parseLong(string);
  }

  @Override
  protected String valueToString(final Long value) {
    return value.toString();
  }
}
