package pegasus.spark.common.io;

import org.apache.log4j.Logger;

import java.io.File;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.Random;

public class LocalPaths {

	private final static Logger LOGGER = Logger.getLogger(LocalPaths.class.getName());
	
	private static final Random rand = new Random();
	
	private static String[] basePaths;
	
	public static void setBasePaths(String[] basePaths){
		
		LOGGER.info("Basepaths: " + Arrays.toString(basePaths));
		
		for(String tmpDir : basePaths){
			new File(tmpDir).mkdirs();
		}
		
		LocalPaths.basePaths = basePaths;
	}
	
	private static String getNextBasePath(){
		return basePaths[rand.nextInt(basePaths.length)];
	}
	
	public static String getTempPath(String prefix){
		
		String res = null;
		do{
			int t = rand.nextInt(Integer.MAX_VALUE);
			res = getNextBasePath() + "/" + prefix + "-" + t;
		}while(Files.exists(Paths.get(res)));
		
		return res;
		
	}
	
}
