package pegasus.spark.cc.deprecated

import org.apache.spark.rdd.RDD
import org.apache.spark.{Partition, TaskContext}

/**
  * Created by hmpark on 17. 6. 8.
  */
class LeftHalfRDD(prev: RDD[((Boolean, Long), Long)])
  extends RDD[(Long, Long)](prev.context, prev.dependencies){

  override def compute(split: Partition, context: TaskContext): Iterator[(Long, Long)] = {
    prev.compute(split.asInstanceOf[LHPartition].getParent, context).map{case ((b, u), v) => (u, v)}
  }

  override protected def getPartitions: Array[Partition] = {
    prev.partitions.slice(0, prev.partitions.length / 2).map{x => new LHPartition(x)}
  }

  class LHPartition(parent: Partition) extends Partition{
    override def index: Int = parent.index
    def getParent = parent
  }
}

class RightHalfRDD(prev: RDD[((Boolean, Long), Long)])
  extends RDD[(Long, Long)](prev.context, prev.dependencies){

  override def compute(split: Partition, context: TaskContext): Iterator[(Long, Long)] = {
    prev.compute(split.asInstanceOf[RHPartition].getParent, context).map{case ((b, u), v) => (u, v)}
  }

  override protected def getPartitions: Array[Partition] = {
    prev.partitions.slice(prev.partitions.length / 2, prev.partitions.length)
      .map{x => new RHPartition(x, prev.partitions.length / 2)}
  }

  class RHPartition(parent: Partition, numParts: Int) extends Partition{
    override def index: Int = parent.index - numParts
    def getParent = parent
  }
}
