package pegasus.spark.common

import org.apache.hadoop.fs.Path

trait Computation {
  def getPartitionedPath(outputPath: String, tempPath: Option[String]): String = tempPath match {
    case Some(path) => new Path(path, "partitioned").toString
    case None => new Path(s"$outputPath.tmp", "partitioned").toString
  }

  def getIntermediatePath(outputPath: String, tempPath: Option[String]): String = tempPath match {
    case Some(path) => new Path(path, "intermediate").toString
    case None => new Path(s"$outputPath.tmp", "intermediate").toString
  }
}
