package pegasus.spark.common

import pegasus.spark.common.io.{VectorReader, VectorWriter}
import pegasus.spark.common.types.{MatrixBlock, VectorBlock}

trait Multiplication[M, V, PV] extends Serializable {
  def createVectorBlock(
    blockId: Int,
    numVertices: Long,
    numBlocks: Int,
    init: Boolean,
    context: MultiplicationContext
  ): VectorBlock[V]

  def createVectorReader(vectorPath: String, blockId: Int): VectorReader[V]

  def createVectorWriter(vectorPath: String, blockId: Int): VectorWriter[V]

  def createIntermediateVectorBlock(
    numVertices: Long,
    numBlocks: Int,
    blockId: Int,
    context: MultiplicationContext
  ): VectorBlock[PV]

  def createIntermediateVectorReader(vectorPath: String, blockId: Int): VectorReader[PV]

  def createIntermediateVectorWriter(vectorPath: String, blockId: Int): VectorWriter[PV]

  def combine2Op(
    matrix: MatrixBlock[M],
    vector: VectorBlock[V],
    result: VectorBlock[PV],
    context: MultiplicationContext
  ): Unit

  def combineAllOp(input: VectorReader[PV], output: VectorBlock[PV], context: MultiplicationContext): Unit

  def applyOp(result: VectorBlock[V], intermediate: VectorBlock[PV], context: MultiplicationContext): Unit
}
