package pegasus.spark.common.io

import scala.reflect.ClassTag

class BufferedReader[@specialized(Int, Long, Double) T: ClassTag](reader: FileReader[T])
  extends Iterator[T] with AutoCloseable {
  private var _head: T = _
  private var headDefined = false

  def head: T = {
    if (!headDefined) {
      _head = reader.next()
      headDefined = true
    }

    _head
  }

  override def hasNext: Boolean = headDefined || reader.hasNext

  override def next(): T = {
    if (headDefined) {
      headDefined = false
      _head
    } else reader.next()
  }

  override def close(): Unit = reader.close()
}
