package pegasus.spark.common.io

import java.io.{DataInputStream, EOFException}

import org.apache.hadoop.fs.Path
import pegasus.spark.common.PMVUtils

class CardinalityReader(path: String, blockId: Int) extends AutoCloseable {
  private val pathObj = new Path(path)
  private val in: DataInputStream = {
    val fs = pathObj.getFileSystem(PMVUtils.hadoopConf())
    fs.open(pathObj)
  }
  private var id = 0L
  private var iter = 0
  private var cardinality = 0.0

  def next(): Boolean = {
    try {
      id = in.readLong()
      iter = in.readInt()
      cardinality = in.readDouble()

      true
    } catch {
      case _: EOFException => false
    }
  }

  def currentRecord: (Long, Int, Double) = (id, iter, cardinality)

  override def close(): Unit = {
    in.close()
  }
}
