package pegasus.spark.common.io

import java.io.DataOutputStream

import org.apache.hadoop.fs.Path
import pegasus.spark.common.PMVUtils

class CardinalityWriter(path: String, blockId: Int) extends AutoCloseable {
  private val pathObj = new Path(path)
  private val out: DataOutputStream = {
    val fs = pathObj.getFileSystem(PMVUtils.hadoopConf())
    if (fs.exists(pathObj)) fs.append(pathObj)
    else fs.create(pathObj, 1.toShort)
  }

  def write(id: Long, iter: Int, cardinality: Double): Unit = {
    out.writeLong(id)
    out.writeInt(iter)
    out.writeDouble(cardinality)
  }

  override def close(): Unit = {
    out.close()
  }
}
