package pegasus.spark.common.io

import java.io.EOFException
import java.nio.BufferUnderflowException

class DoubleFileReader(path: String) extends FileReader[Double](path) {
  override def next(): Double = {
    try {
      buffer.getDouble()
    } catch {
      case _: BufferUnderflowException =>
        fillBuf()
        if (buffer.hasRemaining) {
          buffer.getDouble()
        } else {
          throw new EOFException()
        }
    }
  }
}
