package pegasus.spark.common.io

import java.nio.BufferOverflowException

class DoubleFileWriter(path: String) extends FileWriter[Double](path) {
  override def write(value: Double): Unit = {
    try {
      buffer.putDouble(value)
    } catch {
      case _: BufferOverflowException =>
        flush()
        buffer.putDouble(value)
    }
  }
}
