package pegasus.spark.common.io

import java.io.EOFException
import java.nio.BufferUnderflowException

class IntFileReader(path: String) extends FileReader[Int](path) {
  override def next(): Int = {
    try {
      buffer.getInt()
    } catch {
      case _: BufferUnderflowException =>
        fillBuf()
        if (buffer.hasRemaining) {
          buffer.getInt()
        } else {
          throw new EOFException()
        }
    }
  }
}
