package pegasus.spark.common.io

import java.nio.BufferOverflowException

class IntFileWriter(path: String) extends FileWriter[Int](path) {
  override def write(value: Int): Unit = {
    try {
      buffer.putInt(value)
    } catch {
      case _: BufferOverflowException =>
        flush()
        buffer.putInt(value)
    }
  }
}
