package pegasus.spark.common.io

import java.nio.BufferOverflowException

class LongDoublePairWriter(path: String) extends FileWriter[(Long, Double)](path) {
  override def write(value: (Long, Double)): Unit = {
    try {
      buffer.putLong(value._1)
    } catch {
      case _: BufferOverflowException =>
        flush()
        buffer.putLong(value._1)
    }

    try {
      buffer.putDouble(value._2)
    } catch {
      case _: BufferOverflowException =>
        flush()
        buffer.putDouble(value._2)
    }
  }
}
