package pegasus.spark.common.io

import java.io.EOFException
import java.nio.BufferUnderflowException

class LongFileReader(path: String) extends FileReader[Long](path) {
  override def next(): Long = {
    try {
      buffer.getLong()
    } catch {
      case _: BufferUnderflowException =>
        fillBuf()
        if (buffer.hasRemaining) {
          buffer.getLong()
        } else {
          throw new EOFException()
        }
    }
  }
}
