package pegasus.spark.common.io

import java.nio.BufferOverflowException

class LongFileWriter(path: String) extends FileWriter[Long](path) {
  override def write(value: Long): Unit = {
    try {
      buffer.putLong(value)
    } catch {
      case _: BufferOverflowException =>
        flush()
        buffer.putLong(value)
    }
  }
}
