package pegasus.spark.common.io

import pegasus.spark.common.Constants

import scala.reflect.ClassTag

class MemoryGroupedIterator[@specialized(Int, Long, Double) T: ClassTag](
  keys: Array[Int],
  values: Array[T],
  numInstances: Int
) extends Iterator[(Int, Int, Array[T])] {
  private var current = 0
  private var tempArr: Array[T] = Array.ofDim[T](Constants.InitArrayWritableSize)

  override def hasNext: Boolean = current < numInstances

  override def next(): (Int, Int, Array[T]) = {
    val key = keys(current)

    var i = current
    var flag = i < numInstances
    var count = 0
    while (flag) {
      if (key == keys(i)) {
        if (count >= tempArr.length) {
          val newValue = Array.ofDim[T](tempArr.length * 2)
          Array.copy(tempArr, 0, newValue, 0, tempArr.length)
          tempArr = newValue
        }
        tempArr(count) = values(i)
        count += 1
      }
      i += 1
      flag = i < numInstances && key == keys(i)
    }
    current = i

    (key, count, tempArr.slice(0, count))
  }
}
