package pegasus.spark.common.io

import pegasus.spark.common.Constants

class UnweightedMatrixReader(path: String) extends MatrixReader[Int](path) {
  private var rows = Array.ofDim[Int](Constants.InitArrayWritableSize)

  override protected def readRows(): Array[Int] = {
    val head = dataIn.readInt()
    if ((head & Int.MinValue) != 0) {
      val length = dataIn.readInt()
      val rowsLocal = if (rows.length < length) {
        rows = Array.ofDim[Int](length)
        rows
      } else {
        rows
      }

      var i = 1
      rowsLocal(0) = head & Int.MaxValue
      while (i < length) {
        rowsLocal(i) = dataIn.readInt()
        i += 1
      }
      rowsLocal.slice(0, length)
    } else {
      Array(head)
    }
  }
}
