package pegasus.spark.common.io

class UnweightedMatrixWriter(path: String) extends MatrixWriter[Int](path) {
  override protected final def writeRows(rows: Array[Int]): Unit = {
    if (rows.length > 1) {
      dataOut.writeInt(rows(0) | Int.MinValue)
      dataOut.writeInt(rows.length)
      var i = 1
      while (i < rows.length) {
        dataOut.writeInt(rows(i))
        i += 1
      }
    } else {
      dataOut.writeInt(rows(0))
    }
  }
}
