package pegasus.spark.common.io

class WeightedMatrixWriter(path: String) extends MatrixWriter[(Int, Double)](path) {
  override protected final def writeRows(rows: Array[(Int, Double)]): Unit = {
    if (rows.length > 1) {
      dataOut.writeInt(rows(0)._1 | Int.MinValue)
      dataOut.writeDouble(rows(0)._2)
      dataOut.writeInt(rows.length)
      var i = 1
      while (i < rows.length) {
        dataOut.writeInt(rows(i)._1)
        dataOut.writeDouble(rows(i)._2)
        i += 1
      }
    } else {
      dataOut.writeInt(rows(0)._1)
      dataOut.writeDouble(rows(0)._2)
    }
  }
}
