package pegasus.spark.common.partitioner

import org.apache.spark.Partitioner

class TaskPartitioner(override val numPartitions: Int) extends Partitioner {
  override def getPartition(key: Any): Int = key.asInstanceOf[Int]

  def canEqual(other: Any): Boolean = other.isInstanceOf[TaskPartitioner]

  override def equals(other: Any): Boolean = other match {
    case that: TaskPartitioner =>
      (that canEqual this) &&
        numPartitions == that.numPartitions
    case _ => false
  }

  override def hashCode(): Int = {
    val state = Seq(numPartitions)
    state.map(_.hashCode()).foldLeft(0)((a, b) => 31 * a + b)
  }
}
