package pegasus.spark.common.types

import pegasus.spark.common.Constants

class UnweightedMatrixRows extends MatrixRows[Int] {
  private var rows = Array.ofDim[Int](Constants.InitArrayWritableSize)
  private var length = 0

  override final def size(): Int = length

  override final def row(i: Int): Int = rows(i)

  override final def setRows(rows: Array[Int], begin: Int, end: Int): Unit = {
    val length = end - begin
    if (this.rows.length < length) {
      this.rows = Array.ofDim[Int](length)
    }
    Array.copy(rows, begin, this.rows, 0, length)
    this.length = length
  }
}
