package pegasus.spark.common.types

import pegasus.spark.common.Constants

class WeightedMatrixRows extends MatrixRows[(Int, Double)] {
  private var rows = Array.ofDim[Int](Constants.InitArrayWritableSize)
  private var values = Array.ofDim[Double](Constants.InitArrayWritableSize)
  private var length = 0

  override final def size(): Int = length

  override final def row(i: Int): (Int, Double) = (rows(i), values(i))

  def setRows(rows: Array[Int], values: Array[Double], begin: Int, end: Int): Unit = {
    val length = end - begin
    if (this.rows.length < length) {
      this.rows = Array.ofDim[Int](length)
      this.values = Array.ofDim[Double](length)
    }

    var i = begin
    while (i < end) {
      this.rows(i - begin) = rows(i)
      this.values(i - begin) = values(i)
      i += 1
    }

    this.length = length
  }

  override final def setRows(rows: Array[(Int, Double)], begin: Int, end: Int): Unit = {
    setRows(rows.map(_._1), rows.map(_._2), begin, end)
  }
}
