package pegasus.spark.netray

import org.apache.spark.util.AccumulatorV2

class MaxAccumulator extends AccumulatorV2[Long, Long] {
  private var _value = Long.MinValue

  override def isZero: Boolean = _value == Long.MinValue

  override def copy(): AccumulatorV2[Long, Long] = new MaxAccumulator

  override def reset(): Unit = _value = Long.MinValue

  override def add(v: Long): Unit = {
    if (_value < v) {
      _value = v
    }
  }

  override def merge(other: AccumulatorV2[Long, Long]): Unit = add(other.value)

  override def value: Long = _value
}
