package pegasus.spark.graphgen

import java.io.{BufferedWriter, FileWriter}

import org.sameersingh.scalaplot.Implicits._
import org.sameersingh.scalaplot.Style.PointType
import org.sameersingh.scalaplot.XYPlotStyle
import org.scalatest.{FlatSpec, Matchers}


/**
  * Created by hmpark on 17. 3. 10.
  */
class RMATSinglePerfSpec extends FlatSpec with Matchers {

//  val level = 18
//  val numEdges = 2000000L
  val abcd = (0.57, 0.19, 0.19, 0.05)
  val noise = 0

  "RMAT" should "run without error" in {

    for (level <- 18 to 21) {

      println("level: " + level)

      val numEdges = 16 * Math.pow(2,level).toLong

      var t = System.currentTimeMillis()

//      t = System.currentTimeMillis()
//      RMATSingle.generateAsOriginal(level, numEdges, 0, abcd).foreach { _ => }
//      println("original RMAT:\t" + (System.currentTimeMillis() - t))
//
//      t = System.currentTimeMillis()
//      RMATSingle.generateWithMultinomial(level, numEdges, 0, 100000, abcd).foreach { _ => }
//      println("Mult         :\t" + (System.currentTimeMillis() - t))

      t = System.currentTimeMillis()
      RMATSingle.genMultSRand(level, numEdges, 0, 100000, abcd).foreach { _ => }
      println("MultSRand     :\t" + (System.currentTimeMillis() - t))

      t = System.currentTimeMillis()
      RMATSingle.genMultSRandPar(level, numEdges, 0, 100000, abcd).foreach { _ => }
      println("MultSRandPar  :\t" + (System.currentTimeMillis() - t))

      t = System.currentTimeMillis()
      RMATSingle.genMultSRand(level, numEdges, 0, 100000, abcd).foreach { _ => }
      println("MultSRand     :\t" + (System.currentTimeMillis() - t))

      t = System.currentTimeMillis()
      RMATSingle.genMultSRandPar(level, numEdges, 0, 100000, abcd).foreach { _ => }
      println("MultSRandPar  :\t" + (System.currentTimeMillis() - t))

    }
  }


}
